# Chat server and client
Chat server is a websocket server that allows users to communicate. Chat client library and chat client application can be used by users to send messages between them.

## Requirements
* C++ compiler with C++20 support
* Qt library (latest LTS supported)
* Qt websockets library

## Components
This project consists of 4 components:
* websocket server - Server handles communication between client. For more info click [here](server/README.md).
* websocket client - The library that handles communication with server.
* websocket chat - This is a QWidget based application, which you can use to connect to server and send messages.
* websocket common library - The library contains common code that both server and client are using. It specifies how the messages look ([Protocol description](wschatcom/ProtocolDescription.md)).

## Build

```
mkdir build
cd build
cmake ../
make
```

## Run
The server and chat folders contain server and chat application executables respectively. Running both on the same machine automatically connects client to server through "ws://localhost:1234" URL.