#include "register.h"
#include "ui_register.h"

Register::Register(QWidget *parent) :
    QDialog(parent),
    ui(std::make_unique<Ui::Register>())
{
    ui->setupUi(this);
}

void Register::on_passcheckEdit_textChanged(const QString &arg1)
{
    if (arg1 != ui->passwordEdit->text())
        ui->messageLabel->setText("Passwords dont match!");
    else
        ui->messageLabel->setText("");
}

void Register::on_passwordEdit_textChanged(const QString &arg1)
{
    on_passcheckEdit_textChanged(arg1);
}

Register::~Register() = default;

void Register::on_registerButton_clicked()
{
    if (ui->nameEdit->text() == "") {
        ui->messageLabel->setText("Name cannot be empty!");
        return;
    }
    if (ui->nameEdit->text() == "SERVER") {
        ui->messageLabel->setText("This name is reserved for server!");
        return;
    }
    if (ui->passwordEdit->text() != ui->passcheckEdit->text()) {
        ui->messageLabel->setText("Passwords dont match!");
        return;
    }

    emit register_clicked(ui->nameEdit->text(), ui->passwordEdit->text());
    this->close();
}

void Register::on_cancelButton_clicked()
{
    this->close();
}
