# Protocol
## Communication  
Client connects to the server using a websocket and server's IP/url.
A websocket works as a TCP socket, but upon connection sends a request to the server and only if it receives corresponding response,
the TCP tunnel is setup.

## Message format  
All messages exchanged between a server and a client are in JSON format. 
The currently are 10 message types (see Message::Type in common/Message.h) that determine purpose of each message.

## Action description
- Login:  a client sends Type::LOGIN message to the server and awaits an Type::INFO message informing whether the login was successful
        login may fail due to a non existent name or if the password doesnt correspond to the name
        if the login was successful, server automatically sends Type::CONTACT_LIST_RESPONSE with contacts list tied to the logged in user

- Registering: a client sends Type::REGISTER message to the server and awaits an Type::INFO message informing whether the login was successful
             registering may fail due to a duplicate name
             
- Logout: a client sends Type::LOGOUT message to the server, the server closes the connection between the two

- Adding a friend:  a client sends Type::FRIEND_REQUEST message to the server, 
                  if the requested friend exists it is added to the sender's contact list and this is updated in the server's database
                  subsequently, a Type::CONTACT_LIST_RESPONSE message is sent back
                  if the requested friend doesn't exist, the server responds with Type::INFO message, informing about the failure to add a friend

- Deleting a friend:  a client sends Type::UNFRIEND_REQUEST message to the server, 
                    sever deletes the friend from the sender's contact list and sends back updated Type::CONTACT_LIST_RESPONSE message
                   
- Accepting a friend request:  not supported yet (Type::FRIEND_REQUEST_RESPONSE)
 
- Sending a text message:  client sends a Type::TEXT message to the server, the server updates conversation between the sender and recipient
                         subsequently sends the same Type::TEXT message to the recipient